#############################################################################
#!
#! This is a tmake template for building UNIX applications.
#!
#${
    if ( Config("warn_off") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_WARN_OFF');
    } elsif ( Config("warn_on") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_WARN_ON');
    }
    if ( Config("debug") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_DEBUG');
	Project('TMAKE_LFLAGS += $$TMAKE_LFLAGS_DEBUG');
    } elsif ( Config("release") ) {
	Project('TMAKE_CFLAGS += $$TMAKE_CFLAGS_RELEASE');
	Project('TMAKE_LFLAGS += $$TMAKE_LFLAGS_RELEASE');
    }
    if ( Config("qt") || Config("opengl") ) {
	Project('CONFIG *= x11lib');
	if ( Config("opengl") ) {
	    Project('CONFIG *= x11inc');
	}
    }
    if ( Config("x11") ) {
	Project('CONFIG *= x11lib');
	Project('CONFIG *= x11inc');
    }
    if ( Config("qt") ) {
	$moc_aware = 1;
	AddIncludePath(Project('TMAKE_INCDIR_QT'));
	if ( Config("opengl") ) {
	    Project('TMAKE_LIBDIR_QT') &&
		Project('TMAKE_LIBS *= -L$$TMAKE_LIBDIR_QT');
	    Project('TMAKE_LIBS *= $$TMAKE_LIBS_QT_OPENGL');
	}
	Project('TMAKE_LIBDIR_QT') &&
	    Project('TMAKE_LIBS *= -L$$TMAKE_LIBDIR_QT');
	Project('TMAKE_LIBS *= $$TMAKE_LIBS_QT');
    }
    if ( Config("opengl") ) {
	AddIncludePath(Project('TMAKE_INCDIR_OPENGL'));
	Project('TMAKE_LIBDIR_OPENGL') &&
	    Project('TMAKE_LIBS *= -L$$TMAKE_LIBDIR_OPENGL');
	Project('TMAKE_LIBS *= $$TMAKE_LIBS_OPENGL');
    }
    if ( Config("x11inc") ) {
	AddIncludePath(Project('TMAKE_INCDIR_X11'));
    }
    if ( Config("x11lib") ) {
	Project('TMAKE_LIBDIR_X11') &&
	    Project('TMAKE_LIBS *= -L$$TMAKE_LIBDIR_X11');
	Project('TMAKE_LIBS *= $$TMAKE_LIBS_X11');
    }
    if ( Config("dll") ) {
	$project{"TARGET_EXT"} = ".so";
	Project('TMAKE_LFLAGS_SONAME') &&
	    ($project{"TMAKE_LFLAGS_SONAME"} .= $project{"TARGET"} . $project{"TARGET_EXT"});
	Project('TMAKE_CFLAGS *= $$TMAKE_CFLAGS_SHLIB' );
	Project('TMAKE_LFLAGS *= $$TMAKE_LFLAGS_SHLIB $$TMAKE_LFLAGS_SONAME');
    } else {
	$project{"TARGET_EXT"} = "";
    }
    Project('TMAKE_LIBS += $$LIBS');
    if ( !Project('TMAKE_COMPILE') ) {
	Project('TMAKE_COMPILE = $(CC) -c $(CFLAGS) $(INCPATH) -o $obj $src');
    }
    if ( !Project('TMAKE_COMPILE_IMP') ) {
	Project('TMAKE_COMPILE_IMP = $(CC) -c $(CFLAGS) $(INCPATH) -o $@ $<');
    }
    Project('TMAKE_FILETAGS = HEADERS SOURCES TARGET DESTDIR $$FILETAGS');
    StdInit();
    $project{"TARGET"} = FixPath($project{"DESTDIR"}) . $project{"TARGET"} .
			 $project{"TARGET_EXT"};
#$}
#!
# Makefile for building #$ Expand("TARGET")
# Generated by tmake at #$ Now();
#     Project: #$ Expand("PROJECT");
#    Template: #$ Expand("TEMPLATE");
#############################################################################

####### Compiler, tools and options

CC	=	#$ Expand("TMAKE_CC");
CFLAGS	=	#$ Expand("TMAKE_CFLAGS"); ExpandGlue("DEFINES","-D"," -D","");
INCPATH	=	#$ ExpandGlue("INCPATH","-I"," -I","");
LINK	=	#$ Expand("TMAKE_LINK");
LFLAGS	=	#$ Expand("TMAKE_LFLAGS");
LIBS	=	#$ Expand("TMAKE_LIBS");
MOC	=	#$ Expand("TMAKE_MOC");

####### Files

HEADERS =	#$ ExpandList("HEADERS");
SOURCES =	#$ ExpandList("SOURCES");
OBJECTS =	#$ ExpandList("OBJECTS");
SRCMOC	=	#$ ExpandList("SRCMOC");
OBJMOC	=	#$ ExpandList("OBJMOC");
TARGET	=	#$ Expand("TARGET");

####### Implicit rules

.SUFFIXES: .cpp .cxx .cc .C .c

.cpp.o:
	#$ Expand("TMAKE_COMPILE_IMP");

.cxx.o:
	#$ Expand("TMAKE_COMPILE_IMP");

.cc.o:
	#$ Expand("TMAKE_COMPILE_IMP");

.C.o:
	#$ Expand("TMAKE_COMPILE_IMP");

.c.o:
	#$ Expand("TMAKE_COMPILE_IMP");

####### Build rules

all: #$ ExpandGlue("ALL_DEPS",""," "," "); $text .= '$(TARGET)';

$(TARGET): $(OBJECTS) $(OBJMOC) #$ Expand("TARGETDEPS");
	$(LINK) $(LFLAGS) -o $(TARGET) $(OBJECTS) $(OBJMOC) $(LIBS)

moc: $(SRCMOC)

#$ TmakeSelf();

clean:
	-rm -f $(OBJECTS) $(OBJMOC) $(SRCMOC) $(TARGET)
	#$ ExpandGlue("TMAKE_CLEAN","-rm -f "," ","");
	-rm -f *~ core
	#$ ExpandGlue("CLEAN_FILES","-rm -f "," ","");

####### Compile

#$ BuildObj(Project("OBJECTS"),Project("SOURCES"));
#$ BuildMocObj(Project("OBJMOC"),Project("SRCMOC"));
#$ BuildMocSrc(Project("HEADERS"));
#$ BuildMocSrc(Project("SOURCES"));
